<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class AddOnepercentToGadaiTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */

    /**
     *
     * @var object $db_connection
     */


    public function getActiveDB(){
        $config_db = array_keys(config("database.connections"));

        $db_connection = array_filter($config_db,function($connection){
            try{
                if($connection == 'mysql7' || $connection == 'lelong')
                    return false;

                $db = DB::connection($connection)->getPdo();
                return true;
            } catch(\Exception $e){
                Log::info($connection);
                return false;
            }
        });
        return $db_connection;
    }

    public function up()
    {
        $db_connection = $this->getActiveDB();

        foreach($db_connection as $dbase){
            Schema::connection($dbase)->table('gadai', function (Blueprint $table) use($dbase) {

                $isKadarUjrahExist = Schema::connection($dbase)->hasColumn('gadai', 'kadarujrah');
                $isUjrahExist = Schema::connection($dbase)->hasColumn('gadai', 'ujrah');
                $isOnePercentExist = Schema::connection($dbase)->hasColumn('gadai', 'onepercent');
                $isMarginSemasaExist = Schema::connection($dbase)->hasColumn('gadai', 'margin_semasa');
                $isTagbaruExist = Schema::connection($dbase)->hasColumn('gadai', 'tagbaru');

                if(! $isKadarUjrahExist){
                    $table->decimal('kadarujrah', 5, 2);
                }

                if(! $isUjrahExist){
                    $table->decimal('ujrah', 9, 2);
                }

                if(! $isOnePercentExist){
                    $table->decimal('onepercent', 9, 2);
                }

                if(! $isMarginSemasaExist){
                    $table->decimal('margin_semasa', 5, 2);
                }

                if(! $isTagbaruExist){
                    $table->tinyInteger('tagbaru')->default(0);
                }

            });
        }

    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        $db_connection = $this->getActiveDB();

        foreach($db_connection as $dbase){
            $columns = ['kadarujrah', 'ujrah', 'onepercent','margin_semasa','tagbaru'];


            $columns_exist = array_filter($columns,function($column) use($dbase){
                return Schema::connection($dbase)->hasColumn('gadai', $column);
            });

            Schema::connection($dbase)->table('gadai', function(Blueprint $table) use($columns_exist){
                foreach($columns_exist as $column){
                        $table->dropColumn($column);
                }
            });
        }
    }
}
